<template>
  <VCard :elevation="12" class="pa-5 text-center">
    <VCardTitle class="headline justify-center">
      <b>Bem vindo</b>
    </VCardTitle>

    <VForm ref="formLogin" v-model="login.valid" @submit.prevent="submit">
      <VCardText class="pt-4 subtitle-1">
        <p>Conecte sua conta com <b class="warning--text">admin</b></p>

        <VTextField
          v-model="login.form.name"
          label="Nome do Usuário"
          :rules="[rules.required]"
          :loading="loading"
          :disabled="loading"
          outlined
        />
        <VTextField
          v-model="login.form.password"
          label="Senha"
          :type="login.showPass ? 'text' : 'password'"
          :append-icon="login.showPass ? 'mdi-eye-off' : 'mdi-eye'"
          :rules="[rules.required, rules.minLenght(5, 'Mínimo 5 caracteres')]"
          :loading="loading"
          :disabled="loading"
          outlined
          @click:append="login.showPass = !login.showPass"
        />
      </VCardText>
      <VCardActions class="pa-4">
        <VSpacer />
        <VBtn
          :loading="loading"
          :class="!login.valid && 'v-btn--disabled'"
          type="submit"
          color="warning"
          depressed
        >
          Conectar
        </VBtn>
      </VCardActions>
    </VForm>
  </VCard>
</template>

<script lang="ts">
import { Component, mixins, namespace } from 'nuxt-property-decorator'
import { OnMsg, OnRules } from '@/mixins'

import { getUrlNext, wait } from '@/utils'
import { onLogin } from '@/data/msg.json'

const accountModule = namespace('account')

@Component({
  layout: 'login',
})
export default class PageLogin extends mixins(OnMsg, OnRules) {
  @accountModule.Action
  initAccount!: () => void

  @accountModule.Action
  signIn!: (payload: object) => Promise<void>

  @accountModule.Action
  checkUserExist!: () => Promise<void>

  loading = false

  login = {
    valid: true,
    showPass: false,
    form: {
      name: '',
      password: '',
    },
  }

  mounted() {
    // Reset data logout
    if (Object.keys(this.$route.meta).length > 0) {
      this.initAccount()
    }
  }

  async submit() {
    this.loading = true

    try {
      await this.signIn(this.login.form)
      await this.checkUserExist()

      this.redirect()
    } catch (err) {
      console.error(err)

      this.onMsg(err, 'error')
      this.loading = false
    }
  }

  async redirect() {
    this.onMsg(onLogin, 'success')
    await wait(1000)
    this.$router.push(getUrlNext(this.$route.query))
  }

  head() {
    return { title: 'Login' }
  }
}
</script>
